#include <stdio.h>

#include "PID.h"
#include "type_def.h"
#include "communication.h"
#include "computation_graph.h"
#include "timer.h"

#define ON 1
#define OFF 0
#define ERROR -1

#define SEND_RT_ID 20

#define QUAD_HEIGHT_FLAG	0x80000000
#define X_FLOW_FLAG		0x40000000
#define Y_FLOW_FLAG		0x20000000
#define X_FILTER_FLAG		0x10000000
#define Y_FILTER_FLAG		0x08000000
#define X_VELOCITY_FLAG		0x04000000
#define Y_VELOCITY_FLAG		0x02000000
#define X_GYRO_FLAG		0x01000000
#define Y_GYRO_FLAG		0x00800000
#define Z_GYRO_FLAG		0x00400000
#define X_ACCEL_FLAG		0x00200000
#define Y_ACCEL_FLAG		0x00100000
#define Z_ACCEL_FLAG		0x00080000
#define X_MAG_FLAG		0x00040000
#define Y_MAG_FLAG		0x00020000
#define Z_MAG_FLAG		0x00010000
#define LIDAR_ERR_FLAG		0x00008000
#define LIDAR_CONSEC_ERR_FLAG	0x00004000
#define OPTFL_ERR_FLAG		0x00002000
#define OPTFL_CONSEC_ERR_FLAG	0x00001000
#define IMU_ERR_FLAG		0x00000800
#define IMU_CONSEC_ERR_FLAG	0x00000400	

void initializeFlags( SensorRTFlags_t * flag_pointer);

void freeFlags(SensorRTFlags_t * flags);

int send_RT_data(struct CommDriver *comm, raw_sensor_t * data, SensorRTFlags_t * flags);

u32 shift(u32 data, int position);

